<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8" />
    <title>Karyawan API</title>

    <link rel="stylesheet" href="/css/bootstrap.min.css">

</head>

<body class="bg-light">
    <nav class="navbar navbar-expand-lg navbar-light bg-white border-bottom">
        <a class="navbar-brand" href="#">Cuti</a>
    </nav>
    <div class="container-fluid">
        <div class="row" style="min-height: 93.8vh">
            <div class="col-md-2 bg-white shadow">
                <div class="list-group mt-3">
                    <a href="/jenis_cuti/index" class="list-group-item list-group-item-action ">Jenis Cuti</a>
                    <a href="/jenis_karyawan/index" class="list-group-item list-group-item-action ">Jenis Karyawan</a>
                    <a href="/karyawan/index" class="list-group-item list-group-item-action active">Karyawan</a>
                    <a href="/status/index" class="list-group-item list-group-item-action">Status</a>
                    <a href="/cuti/index" class="list-group-item list-group-item-action">Cuti</a>
                    <a href="/cuti_approval/index" class="list-group-item list-group-item-action">Cuti Approval</a>
                </div>
            </div>
            <div class="col-md-10">
                <div class="card mt-3">
                    <div class="card-body shadow">
                        <h2> Karyawan API</h2>
                        <p>
                            <button class="btn btn-primary" onclick="OpenList(0, 5)">Open List</button>
                            <button class="btn btn-primary" onclick="OpenForm()">Open Add Form</button>
                        </p>
                        <input class="form-control" type="text" placeholder="Search" onkeyup="SearchKaryawan(this.value)" autocomplete="off">
                        <div id="karyawanList"></div>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <script src="/js/jquery-3.5.1.min.js"></script>
    <script src="/js/bootstrap-bundle.min.js"></script>

    <script>
        function OpenList() {
            $.ajax({
                url: '/api/karyawan',
                type: 'get',
                contentType: 'application/json',
                success: function(data) {
                    var table = '<table class="table table-hover">';

                    table += "<tr>";
                    table += "<th> # </th>";
                    table += "<th> Nama Karyawan </th>";
                    table += "<th> Email </th>";
                    table += "<th> Password</th>";
                    table += "<th> Jenis Karyawan</th>";
                    table += "<th> Sisa Cuti</th>";
                    table += "<th> Action</th>";
                    table += "</tr>";

                    for (let i = 0; i < data.length; i++) {
                        table += "<tr>";
                        table += "<td>" + (i + 1) + "</td>";
                        table += "<td>" + data[i].nama + "</td>";
                        table += "<td>" + data[i].email + "</td>";
                        table += "<td>" + data[i].password + "</td>";
                        table += "<td>" + data[i].jenisKaryawan.nama + "</td>";
                        table += "<td>" + data[i].sisaCuti + "</td>";
                        table += "<td><button class='btn btn-success' value='" + data[i].id + "' onclick='formEdit(this.value)'>Update</button> " + ' '
                        table += "<button class='btn btn-danger' value='" + data[i].id + "' onclick='formDelete(this.value)'>Delete</button></td>";
                        table += "</tr>"
                    }
                    table += "</table>";
                    $('#karyawanList').html(table);
                }
            });
        }

        function OpenForm() {
            $.ajax({
                url: '/api/jenis_karyawan',
                type: 'GET',
                contentType: 'application/json',
                success: function(data) {
                    var form = '<table class="table table-bordered"';
                    form += "<tr>";
                    form += "<td>Nama Karyawan</td>";
                    form += '<td><input class="form-control" type ="text" id="nama"></td>';
                    form += "</tr>";
                    form += "<tr>";
                    form += "<td>Email Karyawan</td>";
                    form += '<td><input class="form-control" type ="text" id="email"></td>';
                    form += "</tr>";
                    form += "<tr>";
                    form += "<td>Password Karyawan</td>";
                    form += '<td><input class="form-control" type ="password" id="password"></td>';
                    form += "</tr>";
                    form += "<tr>";
                    form += "<td>Jenis Karyawan</td>";
                    form += "<td><select class='custom-select' id='jenis_karyawan_id'>";
                    for (let i = 0; i < data.length; i++) {
                        form += "<option value='" + data[i].id + "'>" + data[i].nama + "</option>";
                    }
                    form += "</select></td>";
                    form += "</tr>";
                    form += "<tr>";
                    form += '<td colspan="2"><button class="btn btn-primary" onclick = "SaveKaryawan(this.value)">Save</button></td>';
                    form += '</tr>';
                    $("#karyawanList").html(form);
                }
            });
        }

        function SaveKaryawan() {
            var formData = '{';
            formData += '"nama":"' + $('#nama').val() + '",';
            formData += '"email":"' + $('#email').val() + '",';
            formData += '"password":"' + $('#password').val() + '",';
            formData += '"jenisKaryawanId":"' + $('#jenis_karyawan_id').val() + '"';
            formData += '}';

            $.ajax({
                url: '/api/karyawan',
                type: 'post',
                contentType: 'application/json',
                data: formData,
                success: function(data) {
                    OpenList(0, 5);


                    var formDataLogin = '{';
                    formDataLogin += '"email":"' + $('#email').val() + '",';
                    formDataLogin += '"password":"' + $('#password').val() + '"';
                    formDataLogin += '}';

                    $.ajax({
                        url: '/api/login',
                        type: 'post',
                        contentType: 'application/json',
                        data: formDataLogin,
                        success: function(data) {
                            OpenList(0, 5);
                        }

                    });
                }
            });
        }

        function formEdit(id) {
            $.ajax({
                url: '/api/karyawan/' + id,
                type: 'get',
                contentType: 'application/json',
                success: function(data) {
                    var form = '<table class="table table-bordered">';
                    form += "<tr>";
                    $.ajax({
                        url: '/api/jenis_karyawan/',
                        type: 'GET',
                        contentType: 'application/json',
                        success: function(dataJenisKaryawan) {
                            form += "<td>Nama</td>";
                            form += "<td><input class='form-control' type='text' id='nama' value='" + data.nama + "'><input class='form-control' type='hidden' id='createdOn' value='" + data.createdOn + "'></td>"
                            form += "</tr>";
                            form += "<tr>";
                            form += "<td>email</td>";
                            form += "<td><input class='form-control' type='text' id='email' value='" + data.email + "'><input class='form-control' type='hidden' id='createdBy' value='" + data.createdBy + "'></td>"
                            form += "</tr>";
                            form += "<tr>";
                            form += "<td>Password</td>";
                            form += '<td><input class="form-control" type="password" id="password" value="' + data.password + '"></td>';
                            form += "</tr>";
                            form += "<tr>";
                            form += "<td>Jenis Karyawan </td>"
                            form += "<td><select class='custom-select' id='jenis_karyawan_id'>"
                            for (let i = 0; i < dataJenisKaryawan.length; i++) {
                                if (dataJenisKaryawan[i].id == data.jenisKaryawanId) {
                                    selected = "selected"
                                } else {
                                    selected = ""
                                }
                                form += "<option value='" + dataJenisKaryawan[i].id + "' " + selected + ">" + dataJenisKaryawan[i].nama + "</option>"
                            }
                            form += "</select></td>";
                            form += "</tr>"
                            form += "<tr>";
                            form += '<td colspan="2"><button class="btn btn-primary" value="' + data.id + '" onclick="UpdateKaryawan(this.value)">Save</button></td>';
                            form += '</tr>';
                            $('#karyawanList').html(form);
                        }
                    });
                }
            });
        }

        function UpdateKaryawan(id) {
            var formData = '{';
            formData += '"nama":"' + $('#nama').val() + '",';
            formData += '"email":"' + $('#email').val() + '",';
            formData += '"password":"' + $('#password').val() + '",';
            formData += '"jenisKaryawanId":"' + $('#jenis_karyawan_id').val() + '",';
            formData += '"createdBy":"' + $('#createdBy').val() + '",'
            formData += '"createdOn":"' + $('#createdOn').val() + '"'
            formData += '}';

            $.ajax({
                url: '/api/karyawan/' + id,
                type: 'put',
                contentType: 'application/json',
                data: formData,
                success: function(data) {
                    OpenList();
                }
            });
        }

        function formDelete(id) {
            $.ajax({
                url: '/api/karyawan/' + id,
                type: 'get',
                contentType: 'application/json',
                success: function(data) {
                    var form = '<table class="table table-bordered">';
                    form += "<tr>";
                    $.ajax({
                        url: '/api/jenis_karyawan/',
                        type: 'GET',
                        contentType: 'application/json',
                        success: function(dataJenisKaryawan) {
                            form += "<td>Nama</td>";
                            form += "<td><input class='form-control' type='text' id='nama' value='" + data.nama + "' disabled><input class='form-control' type='hidden' id='createdOn' value='" + data.createdOn + "'></td>"
                            form += "</tr>";
                            form += "<tr>";
                            form += "<td>email</td>";
                            form += "<td><input class='form-control' type='text' id='email' value='" + data.email + "' disabled><input class='form-control' type='hidden' id='createdOn' value='" + data.createdOn + "'></td>"
                            form += "</tr>";
                            form += "<tr>";
                            form += "<td>Password</td>";
                            form += '<td><input class="form-control" type="password" id="password" value="' + data.password + '" disabled></td>';
                            form += "</tr>";
                            form += "<tr>";
                            form += "<td>Jenis Karyawan </td>"
                            form += "<td><select class='custom-select' id='jenis_karyawan_id' disabled>"
                            for (let i = 0; i < dataJenisKaryawan.length; i++) {
                                if (dataJenisKaryawan[i].id == data.jenisKaryawanId) {
                                    selected = "selected"
                                } else {
                                    selected = ""
                                }
                                form += "<option value='" + dataJenisKaryawan[i].id + "' " + selected + ">" + dataJenisKaryawan[i].nama + "</option>"
                            }
                            form += "</select></td>";
                            form += "</tr>"
                            form += "<tr>";
                            form += '<td colspan="2"><button class="btn btn-danger" value="' + data.id + '" onclick="DeleteKaryawan(this.value)">Save</button></td>';
                            form += '</tr>';
                            $('#karyawanList').html(form);
                        }
                    });
                }
            });
        }

        function DeleteKaryawan(id) {
            var formData = '{';
            formData += '"nama":"' + $('#nama').val() + '",';
            formData += '"email":"' + $('#email').val() + '",';
            formData += '"password":"' + $('#password').val() + '",';
            formData += '"jenisKaryawanId":"' + $('#jenis_karyawan_id').val() + '",';
            formData += '"createdBy":"' + $('#createdBy').val() + '",'
            formData += '"createdOn":"' + $('#createdOn').val() + '"'
            formData += '}';

            $.ajax({
                url: '/api/karyawan/' + id,
                type: 'delete',
                contentType: 'application/json',
                data: formData,
                success: function(data) {
                    OpenList();
                }
            });
        }
    </script>